pdf('../Pdf/varanal.pdf', height=6, width=6, pointsize=10)
load(file='VA_conjugate.rda')
par(mfrow=c(2,2))

# compute variances
VA = -sweep(VA, c(1,3), VA[,'REF',])

# rename titles

titles  =c('Cont. precip (log)', 
           expression(paste('Cont. temp (',degree,'C)')), 
           expression(paste('SST (',degree,'C)')), 
          'Mixed-layer depth (log)')

#x=1
dimnames(VA)[[2]][1] = "precession"
dimnames(VA)[[2]][2] = "obl"

maxes = sqrt ( apply( VA['sv',,], 2, max) * 1.3 )
# rename factors

par(las=1)
for (i in c(2,1,3,4))
{
 barplot(sqrt(VA[c(1,2),seq(4),i]), beside=TRUE, main = titles[i], ylim=c(0, maxes[i]))
}

legend('topright',c('sq. root of post. mean variance','sq. root of  GP variance'), fill=c('grey','black'), cex=.8)
dev.off()

