
 # emulator support for visualiser
 # Michel Crucifix 2014

 lambd <- list(theta=c(ecosw=0.5, esinw=0.5, eps=0.5, ice=0.5, co2=0.5), nugget=0.1)

 RDatapath = file.path('..','Data','RData')
 load(file.path(RDatapath,'exp_output.rda'))
 load(file.path(RDatapath,'lambda.rda'))

 # calibrate a list of emulators 
 # using the lambdas defined above 

 exp = "Orog_without_11_40"
 X <- DATA[[exp]]$X
 colnames(X) = names(attr(X, "scales"))

 require(GP)
                 
 # the following is the function that will effectively be called by the python visualiser
 # so do not forget that we will need a better validation, but keep on:
 P <- function(orog,ice, co2,lambda1,lambda2,lambda3,lambda4,lambda5, nugget)
  {
   exp <- ifelse(orog,"Orog_without_11_40","No_Orog")
   seqgrid <- seq(-1,1,0.2)

   X <- DATA[[exp]]$X
   colnames(X) = names(attr(X, "scales"))
   Y <- DATA[[exp]]$Y[,'temp2'] 


    lambd <- list(theta=c(ecosw=lambda1, esinw=lambda2,
                         eps=lambda3, ice=lambda4, co2=lambda5), nugget=nugget)
 
    E  <- GP_C(X,Y,lambd)

    PD <- expand.grid(ecosw=seqgrid, esinw=seqgrid, eps=seqgrid, ice=ice, co2=co2)
    Yout  <- GP_P(E,as.matrix(PD))
   array(Yout$yp, dim=rep(length(seqgrid),3))
  }





